# remirepo/Fedora spec file for php-zendframework-zend-form
#
# Copyright (c) 2015-2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    284f51cf26af2d3d88936fd8b74d46853550b718*
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-form
%global php_home     %{_datadir}/php
%global library      Form
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.14.3
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-date
BuildRequires:  php-intl
BuildRequires:  php-pcre
BuildRequires:  php-spl
# Temporary, see https://github.com/zendframework/zend-math/issues/23
BuildRequires:  php-mcrypt
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-autoloader(%{gh_owner}/zend-inputfilter)    >= 2.8   with php-autoloader(%{gh_owner}/zend-inputfilter)    < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-hydrator)       >= 1.1   with php-autoloader(%{gh_owner}/zend-hydrator)       < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1 with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
# remirepo:5
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-inputfilter)    >= 2.8
BuildRequires:  php-autoloader(%{gh_owner}/zend-hydrator)       >= 1.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1
%endif
# From composer, "require-dev": {
#        "doctrine/annotations": "~1.0",
#        "zendframework/zend-cache": "^2.6.1",
#        "zendframework/zend-captcha": "^2.7.1",
#        "zendframework/zend-code": "^2.6 || ^3.0",
#        "zendframework/zend-escaper": "^2.5",
#        "zendframework/zend-eventmanager": "^2.6.2 || ^3.0",
#        "zendframework/zend-filter": "^2.6",
#        "zendframework/zend-i18n": "^2.6",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3",
#        "zendframework/zend-session": "^2.8.1",
#        "zendframework/zend-text": "^2.6",
#        "zendframework/zend-validator": "^2.6",
#        "zendframework/zend-view": "^2.6.2",
#        "zendframework/zendservice-recaptcha": "^3.0.0",
#        "phpunit/phpunit": "^5.7.23 || ^6.5.3",
#        "zendframework/zend-coding-standard": "~1.0.0"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-composer(doctrine/annotations)              >= 1.0   with php-composer(doctrine/annotations)              < 2)
BuildRequires: (php-autoloader(%{gh_owner}/zend-cache)          >= 2.6.1 with php-autoloader(%{gh_owner}/zend-cache)          < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-captcha)        >= 2.7.1 with php-autoloader(%{gh_owner}/zend-captcha)        < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-code)           >= 2.6   with php-autoloader(%{gh_owner}/zend-code)           < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-escaper)        >= 2.5   with php-autoloader(%{gh_owner}/zend-escaper)        < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2 with php-autoloader(%{gh_owner}/zend-eventmanager)   < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-filter)         >= 2.6   with php-autoloader(%{gh_owner}/zend-filter)         < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-i18n)           >= 2.6   with php-autoloader(%{gh_owner}/zend-i18n)           < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.5 with php-autoloader(%{gh_owner}/zend-servicemanager) < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-session)        >= 2.8.1 with php-autoloader(%{gh_owner}/zend-session)        < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-text)           >= 2.6   with php-autoloader(%{gh_owner}/zend-text)           < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-validator)      >= 2.6   with php-autoloader(%{gh_owner}/zend-validator)      < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-view)           >= 2.6.2 with php-autoloader(%{gh_owner}/zend-view)           < 3)
%global phpunit %{_bindir}/phpunit6
BuildRequires:  phpunit6 >= 6.5.3
# remirepo:17
%else
BuildRequires:  php-composer(doctrine/annotations)              >= 1.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-cache)          >= 2.6.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-captcha)        >= 2.7.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-code)           >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-escaper)        >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2
BuildRequires:  php-autoloader(%{gh_owner}/zend-filter)         >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-i18n)           >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-session)        >= 2.8.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-text)           >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)      >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-view)           >= 2.6.2
%global phpunit %{_bindir}/phpunit
BuildRequires:  php-phpunit-PHPUnit >= 5.7.23
%endif
# Missing
BuildRequires:  php-composer(ircmaxell/random-lib)
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-inputfilter": "^2.8",
#        "zendframework/zend-hydrator": "^1.1 || ^2.1 || ^3.0",
#        "zendframework/zend-stdlib": "^3.2.1"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-autoloader(%{gh_owner}/zend-inputfilter)    >= 2.8   with php-autoloader(%{gh_owner}/zend-inputfilter)    < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-hydrator)       >= 1.1   with php-autoloader(%{gh_owner}/zend-hydrator)       < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1 with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
# Mandory because of Polyfill
Requires:      (php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.5 with php-autoloader(%{gh_owner}/zend-servicemanager) < 4)
# remirepo:11
%else
Requires:       php-autoloader(%{gh_owner}/zend-inputfilter)    >= 2.8
Requires:       php-autoloader(%{gh_owner}/zend-inputfilter)    <  3
Requires:       php-autoloader(%{gh_owner}/zend-hydrator)       >= 1.1
Requires:       php-autoloader(%{gh_owner}/zend-hydrator)       <  3
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
# Mandory because of Polyfill
Requires:       php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.5
Requires:       php-autoloader(%{gh_owner}/zend-servicemanager) < 4
%endif
# From composer, "suggest": {
#        "zendframework/zend-captcha": "^2.7.1, required for using CAPTCHA form elements",
#        "zendframework/zend-code": "^2.6 || ^3.0, required to use zend-form annotations support",
#        "zendframework/zend-eventmanager": "^2.6.2 || ^3.0, reuired for zend-form annotations support",
#        "zendframework/zend-i18n": "^2.6, required when using zend-form view helpers",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3, required to use the form factories or provide services",
#        "zendframework/zend-view": "^2.6.2, required for using the zend-form view helpers",
#        "zendframework/zendservice-recaptcha": "in order to use the ReCaptcha form element"
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 8
Suggests:       php-autoloader(%{gh_owner}/zend-captcha)
Suggests:       php-autoloader(%{gh_owner}/zend-code)
Suggests:       php-autoloader(%{gh_owner}/zend-eventmanager)
Suggests:       php-autoloader(%{gh_owner}/zend-i18n)
Suggests:       php-autoloader(%{gh_owner}/zend-view)
Suggests:       php-autoloader(%{gh_owner}/zendservice-recaptcha)
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.6.0
Requires:       php-date
Requires:       php-intl
Requires:       php-pcre
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
The Zend\Form is intended primarily as a bridge between your domain models
and the View Layer. It composes a thin layer of objects representing form
elements, an InputFilter, and a small number of methods for binding data to
and from the form and attached objects.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Captcha/autoload.php',
    '%{php_home}/Zend/Code/autoload.php',
    '%{php_home}/Zend/EventManager/autoload.php',
    '%{php_home}/Zend/I18n/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/View/autoload.php',
    '%{php_home}/ZendService/ReCaptcha/autoload.php',
]);
# Polyfill must be loaded after ServiceManager
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/InputFilter/autoload.php',
    '%{php_home}/Zend/Hydrator/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
    __DIR__ . '/formElementManagerPolyfill.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}

cp -p autoload/formElementManagerPolyfill.php \
    %{buildroot}%{php_home}/Zend/%{library}
ln -s %{library}/formElementManagerPolyfill.php \
    %{buildroot}%{php_home}/Zend/%{library}-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
\Fedora\Autoloader\Dependencies::required([
    dirname(__DIR__) . '/test/_autoload.php',
    '%{php_home}/Zend/Cache/autoload.php',
    '%{php_home}/Zend/Escaper/autoload.php',
    '%{php_home}/Zend/Filter/autoload.php',
    '%{php_home}/Zend/Session/autoload.php',
    '%{php_home}/Zend/Text/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
EOF

ret=0
for cmdarg in "php %{phpunit}" php71 php72 php73 php74; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit6} -d memory_limit=1G || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}
%{php_home}/Zend/%{library}-autoload.php


%changelog
* Fri Oct  4 2019 Remi Collet <remi@remirepo.net> - 2.14.3-1
- update to 2.14.3
- drop patch merged upstream

* Fri Oct  4 2019 Remi Collet <remi@remirepo.net> - 2.14.2-1
- update to 2.14.2
- add patch for PHP 7.4 from
  https://github.com/zendframework/zend-form/pull/235

* Wed Feb 27 2019 Remi Collet <remi@remirepo.net> - 2.14.1-1
- update to 2.14.1

* Tue Jan  8 2019 Remi Collet <remi@remirepo.net> - 2.14.0-1
- update to 2.14.0
- raise dependency on zend-stdlib 3.2.1

* Wed Dec 12 2018 Remi Collet <remi@remirepo.net> - 2.13.0-1
- update to 2.13.0
- allow zend-hydrator 3
- use range dependencies

* Wed May 23 2018 Remi Collet <remi@remirepo.net> - 2.12.0-2
- update to 2.12.0

* Tue Dec 12 2017 Remi Collet <remi@remirepo.net> - 2.11.0-3
- zend-servicemanager is mandatory

* Tue Dec 12 2017 Remi Collet <remi@remirepo.net> - 2.11.0-2
- switch from zend-loader to fedora/autoloader

* Thu Dec  7 2017 Remi Collet <remi@remirepo.net> - 2.11.0-1
- Update to 2.11.0
- temporarily switch back to phpunit v5
- raise dependency on zend-inputfilter 2.8
- raise dependency on zend-session 2.8.1

* Tue Oct 24 2017 Remi Collet <remi@remirepo.net> - 2.10.2-3
- fix FTBFS from Koschei, add patch for PHP 7.2 from
  https://github.com/zendframework/zend-form/pull/171

* Mon May 22 2017 Remi Collet <remi@remirepo.net> - 2.10.2-1
- Update to 2.10.2

* Thu Apr 27 2017 Remi Collet <remi@remirepo.net> - 2.10.1-1
- Update to 2.10.1
- raise minimum php version to 5.6
- use phpunit6 on F26+

* Thu Mar  2 2017 Remi Collet <remi@remirepo.net> - 2.10.0-1
- update to 2.10.0
- raise dependency on zend-captcha 2.7.1

* Fri Sep 23 2016 Remi Collet <remi@fedoraproject.org> - 2.9.2-1
- update to 2.9.2

* Thu Sep 15 2016 Remi Collet <remi@fedoraproject.org> - 2.9.1-1
- update to 2.9.1

* Fri Jun 10 2016 Remi Collet <remi@fedoraproject.org> - 2.9.0-1
- update to 2.9.0

* Wed May  4 2016 Remi Collet <remi@fedoraproject.org> - 2.8.3-1
- update to 2.8.3

* Mon May  2 2016 Remi Collet <remi@fedoraproject.org> - 2.8.2-1
- update to 2.8.2
- raise dependency on zend-loader >= 2.5.1-3

* Sun May  1 2016 Remi Collet <remi@fedoraproject.org> - 2.8.1-1
- update to 2.8.1

* Fri Apr  8 2016 Remi Collet <remi@fedoraproject.org> - 2.8.0-1
- update to 2.8.0

* Tue Feb 23 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0
- raise dependency on zend-inputfilter >= 2.6
- raise dependency on zend-hydrator >= 1.1

* Thu Jan 28 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on zend-stdlib ~2.7
- add dependency on zend-hydrator ~1.0

* Wed Sep 23 2015 Remi Collet <remi@fedoraproject.org> - 2.5.3-1
- update to 2.5.3

* Thu Sep 10 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- update to 2.5.2
- raise minimum php version to 5.5

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
